//+------------------------------------------------------------------+
//|                                                     MACD_EMA.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
double mypoint;
extern double be_factor=1.0;
extern int ma=200;
extern int FastMAPeriod=12;
extern int SlowMAPeriod=26;
extern int SignalMAPeriod=9;

extern int Periods=20;

extern bool use_limit=True;
extern double ratio=2; 
extern bool use_chalkin_money_flow=true;
extern double risk=3;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if(Digits==4 || Digits<=2) mypoint=Point;
   if(Digits==3 || Digits==5) mypoint=Point*10;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {if(isthisnewcandle()==True){
  //Alert("im still a live");
 // Comment("MACD[1]-->",macd_1,"\n","MACD[2]-->",macd_2,"SIGNAL[1]-->",signal_1,"\n","SIGNAL[2]-->",signal_2,"\n","MA[1]",ma_1);
  //Comment("HHIHEST 20 BAR-->",highest_bar(20),"\n","LOWEST 20 BAR-->",lowest_bar(20));
  /*  drawlabel("buys",10,35,StringConcatenate("total b-->",total(OP_BUY)),10);
    drawlabel("sellers",10,95,StringConcatenate("total s-->",total(OP_SELL)),10);
    drawlabel("buys st",10,155,StringConcatenate("buy c-->",cheack_buy_condition()),10);
    drawlabel("sellers st",10,215,StringConcatenate("sell c-->",cheack_sell_condition()),10);
 //   drawlabel("statues",10,265,StringConcatenate("MACD[1]-->",NormalizeDouble(macd_1,2)," MACD[2]-->",DoubleToStr(macd_2,2)," SIGNAL[1]-->",signal_1," SIGNAL[2]-->",signal_2," MA[1]",ma_1),10);*/
  if(cheack_buy_condition()==True && total(OP_BUYLIMIT)==0 && total(OP_BUY)==0)
    {
     double buy_triger=Close[1];
     double buy_stop_price=lowest_bar(20);
     double buy_open_price=buy_triger-((buy_triger-buy_stop_price)/2);
     double buy_profit_price=buy_open_price+((buy_open_price-buy_stop_price)*ratio);
     double i_stop_in_pip=(buy_open_price-buy_stop_price)/mypoint;
     double market_buy_profit=Bid+((Bid-buy_stop_price)*ratio);
     double market_buy_stop_in_pip=(Bid-buy_stop_price)/mypoint;
    // datetime sell_exp=TimeCurrent()+(Period()*60*30);
    // OrderSend(Symbol(),OP_BUYLIMIT,CalculateLotSize(i_stop_in_pip,1),NormalizeDouble(buy_open_price,Digits),3,NormalizeDouble(buy_stop_price,Digits),NormalizeDouble(buy_profit_price,Digits),"",0,TimeCurrent()+(Period()*60*30),Red);  
     drawvline();
     SendNotification(StringConcatenate(Symbol(),Period(),"buylimit-->",buy_open_price,"sl-->",buy_stop_price,"tp-->",market_buy_profit));
     SendMail(StringConcatenate(Symbol(),Period()),StringConcatenate(Symbol(),Period(),"buylimit-->",buy_open_price,"sl-->",buy_stop_price,"tp-->",buy_profit_price));
     SendNotification(StringConcatenate(Symbol(),Period(),"buy-->",Ask,"sl-->",buy_stop_price,"tp-->",market_buy_profit));
     SendMail(StringConcatenate(Symbol(),Period()),StringConcatenate(Symbol(),Period(),"buy-->",Ask,"sl-->",buy_stop_price,"tp-->",market_buy_profit));
     if(use_limit==True){OrderSend(Symbol(),OP_BUYLIMIT,CalculateLotSize(i_stop_in_pip,risk),NormalizeDouble(buy_open_price,Digits),3,NormalizeDouble(buy_stop_price,Digits),NormalizeDouble(buy_profit_price,Digits),"",0,TimeCurrent()+(Period()*60*30),Red);}  
     if(use_limit==False){OrderSend(Symbol(),OP_BUY,CalculateLotSize(market_buy_stop_in_pip,risk),Ask,3,NormalizeDouble(buy_stop_price,Digits),NormalizeDouble(market_buy_profit,Digits),"",0,0,Red);}  
     //OrderSend(Symbol(),OP_BUYLIMIT,CalculateLotSize(30,2),Ask,3,Bid-30*mypoint,Bid+45*mypoint,"",0,0,Red);
    }
   if(cheack_sell_condition()==True && total(OP_SELLLIMIT)==0 && total(OP_SELL)==0)
    {
    //drawlabel("ss",200,200,"im in",20);
     double sell_triger=Close[1];
     double sell_stop_price=highest_bar(20);
     double sell_open_price=sell_stop_price-((sell_stop_price-sell_triger)/2);
     double sell_profit_price=sell_open_price-((sell_stop_price-sell_open_price)*ratio);
     double stop_in_pip=(sell_stop_price-sell_open_price)/mypoint;
     double market_sell_profit=Ask-((sell_stop_price-Ask)*ratio);
     double market_sell_in_pip=(sell_stop_price-Ask)/mypoint;
     drawvline();
    // datetime sell_exp=TimeCurrent()+(Period()*60*30);
     SendNotification(StringConcatenate(Symbol(),Period(),"selllimit-->",sell_open_price,"sl-->",sell_stop_price,"tp-->",sell_profit_price));
     SendMail(StringConcatenate(Symbol(),Period()),StringConcatenate(Symbol(),Period(),"selllimit-->",sell_open_price,"sl-->",sell_stop_price,"tp-->",sell_profit_price));
     SendNotification(StringConcatenate(Symbol(),Period(),"sell-->",Bid,"sl-->",sell_stop_price,"tp-->",market_sell_profit));
     SendMail(StringConcatenate(Symbol(),Period()),StringConcatenate(Symbol(),Period(),"sell-->",Bid,"sl-->",sell_stop_price,"tp-->",market_sell_profit));

     if(use_limit==True){OrderSend(Symbol(),OP_SELLLIMIT,CalculateLotSize(stop_in_pip,risk),NormalizeDouble(sell_open_price,Digits),3,NormalizeDouble(sell_stop_price,Digits),NormalizeDouble(sell_profit_price,Digits),"",0,TimeCurrent()+(Period()*60*30),Red); } 
     if(use_limit==False){OrderSend(Symbol(),OP_SELL,CalculateLotSize(market_sell_in_pip,risk),Bid,3,NormalizeDouble(sell_stop_price,Digits),NormalizeDouble(market_sell_profit,Digits),"",0,0,Red); } 
     /*Print("sell sl-->",NormalizeDouble(sell_stop_price,Digits));
     Print("Open price-->",NormalizeDouble(sell_open_price,Digits));
     Print("Take profit-->",NormalizeDouble(sell_profit_price,Digits));*/
     //OrderSend(Symbol(),OP_SELLLIMIT,CalculateLotSize(stop_in_pip,1),NormalizeDouble(sell_open_price,Digits),3,NormalizeDouble(sell_stop_price,Digits),NormalizeDouble(sell_profit_price,Digits)*ratio,"",0,TimeCurrent()+(Period()*60*30),Red);  
    }
  be_cl(25);
  }}
//+------------------------------------------------------------------+
bool isthisnewcandle(){
static int barsonchart=0;
if (Bars==barsonchart)
return (false);
barsonchart=Bars;
return(true);}
int total(int type){
int num=0,i;
for (i=0; i < OrdersTotal(); i++){
if(OrderSelect(i,MODE_TRADES))
if(Symbol()== OrderSymbol()&& OrderType()==type){num++;}
}
return (num);
}
//====================================================================================
double CalculateLotSize(double SL,double risk){           
   double LotSize=0;
   double nTickValue=MarketInfo(Symbol(),MODE_TICKVALUE);
   if(Digits==3 || Digits==5){
      nTickValue=nTickValue*10;
   }
   //We apply the formula to calculate the position size and assign the value to the variable
   LotSize=(AccountBalance()*risk/100)/(SL*nTickValue);
   return LotSize;
}
//====================================================================================
void be_cl(double percentage){
int i;
for(i=OrdersTotal()-1; i>=0; i--){
if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
  {
   if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)
     {
      if(Bid-OrderOpenPrice()>(OrderOpenPrice()-OrderStopLoss()))
        {
      if(OrderStopLoss() != OrderOpenPrice()){
      Print("Moving buy sl from-->",OrderStopLoss()," to-->",OrderOpenPrice());
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
      Print("closing buy-->",OrderLots(),"to become-->",OrderLots()*((100-percentage)/100.0));
      OrderClose(OrderTicket(),OrderLots()*(percentage/100.0),Bid,3,clrYellow);
      }
     }
     }
    if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)
     {
      if(OrderOpenPrice()-Ask>OrderStopLoss()-OrderOpenPrice())
        {
      if(OrderStopLoss()!= OrderOpenPrice() ){
      Print("Moving sell sl from-->",OrderStopLoss()," to-->",OrderOpenPrice());
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
      Print("closing sell-->",OrderLots(),"to become-->",OrderLots()*((100-percentage)/100.0));
      OrderClose(OrderTicket(),OrderLots()*(percentage/100),Ask,3,clrYellow);
      }
      }
     }
  }
}
}
//====================================================================================
void drawtext(string txt){
int xx=MathRand();
string name= IntegerToString(xx);
ObjectCreate (name,OBJ_TEXT,0,0,0);
ObjectCreate(name, OBJ_TEXT, 0,Time[1], Close[1] );
ObjectSetText (name,txt,10,"Calibri",clrWhite);
}
//====================================================================================
void drawlabel(string name,int x,int y,string text,int font_size){
ObjectCreate(name,OBJ_LABEL,0,0,0);
ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
   ObjectSetString(0,name,OBJPROP_TEXT,text);
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetInteger(0,name,OBJPROP_COLOR,Chartreuse);
   ObjectSetInteger(0,name,OBJPROP_SELECTABLE,True);
   ObjectSetInteger(0,name,OBJPROP_SELECTED,True);
   ObjectSetInteger(0,name,OBJPROP_HIDDEN,False);
return; }
//====================================================================================
void drawvline(){
int x=MathRand();
int y=MathRand();
string name= IntegerToString(x+y);
    ObjectCreate(name, OBJ_VLINE, 0, Time[1], 0);
    ObjectSet(name, OBJPROP_WIDTH, 1);
    ObjectSet(name, OBJPROP_COLOR, Blue);
    ObjectSet(name, OBJPROP_BACK, true);
}
//====================================================================================
bool cheack_sell_condition(){
double ma_1=iMA(Symbol(),0,ma,0,MODE_EMA,PRICE_CLOSE,1);
double ma_2=iMA(Symbol(),0,ma,0,MODE_EMA,PRICE_CLOSE,2);
double macd_1=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,0,1);
double macd_2=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,0,2);
double signal_1=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,1,1);
double signal_2=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,1,1);
double chalkin_money=iCustom(Symbol(),0,"chaikin-money-flow-indicator",Periods,0,1);
Comment("MACD[1]-->",macd_1,"MACD[2]-->",macd_2,"SIGNAL[1]-->",signal_1,"\n","SIGNAL[2]-->",signal_2,"\n","MA[1]",ma_1);

if((macd_2>signal_2)&&(macd_1<signal_1)&&(macd_1>0)&&(signal_1>0)&&(High[1]<ma_1))
  {  double buy_triger=Close[1];
     double buy_stop_price=lowest_bar(20);
     double buy_open_price=buy_triger-((buy_triger-buy_stop_price)/2);
     double buy_profit_price=buy_open_price+((buy_open_price-buy_stop_price)*ratio);
     double i_stop_in_pip=(buy_open_price-buy_stop_price)/mypoint;
     double market_buy_profit=Bid+((Bid-buy_stop_price)*ratio);
     double market_buy_stop_in_pip=(Bid-buy_stop_price)/mypoint;
    SendNotification(StringConcatenate("sell signal-->",Symbol()," ",Period(),"m"));
    Alert(StringConcatenate("sell signal-->",Symbol(),Period()));
   //OrderSend(Symbol(),OP_SELL,CalculateLotSize(30,2),Bid,3,Bid+30*mypoint,Bid+45*mypoint,"",0,0,White);
  if(use_chalkin_money_flow==True && chalkin_money<0)
    {
     return true;
    }
   if(use_chalkin_money_flow==True && chalkin_money>0)
    {
     return false;
    }
    return true;
  }
return false;
}
//--------------------------------------------------------------------------------
bool cheack_buy_condition(){
double ma_1=iMA(Symbol(),0,ma,0,MODE_EMA,PRICE_CLOSE,1);
double ma_2=iMA(Symbol(),0,ma,0,MODE_EMA,PRICE_CLOSE,2);
double macd_1=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,0,1);
double macd_2=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,0,2);
double signal_1=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,1,1);
double signal_2=iCustom(Symbol(),0,"MACD True",FastMAPeriod,SlowMAPeriod,SignalMAPeriod,1,1);
double chalkin_money=iCustom(Symbol(),0,"chaikin-money-flow-indicator",Periods,0,1); 
Comment("MACD[1]-->",macd_1,"\n","MACD[2]-->",macd_2,"SIGNAL[1]-->",signal_1,"\n","SIGNAL[2]-->",signal_2,"\n","MA[1]",ma_1);

if((macd_2<signal_2)&&(macd_1>signal_1)&&(macd_1<0)&&(signal_1<0)&&(Low[1]>ma_1))
  {
    SendNotification(StringConcatenate("buy signal-->",Symbol(),Period()));
    Alert(StringConcatenate("buy signal-->",Symbol(),Period()));
   //OrderSend(Symbol(),OP_SELL,CalculateLotSize(30,2),Bid,3,Bid+30*mypoint,Bid+45*mypoint,"",0,0,White);
   if(use_chalkin_money_flow==True && chalkin_money>0)
    {
     return true;
    }
   if(use_chalkin_money_flow==True && chalkin_money<0)
    {
     return false;
    }
    return true;  
  }
return false;
}
double highest_bar(int loock_bars){
return High[iHighest(Symbol(),0,MODE_HIGH,loock_bars,1)];
}
double lowest_bar(int loock_bars){
return Low[iLowest(Symbol(),0,MODE_HIGH,loock_bars,1)];
}



